/*
     Object Oriented Programming using C++,
     Solution Manual and Applied Examples.
	    written by Dr. Farschad Torabi
     K. N. Toosi University of Technology  
	           September, 2013

                 Program 16.1
*/

#include<stdio.h>
#include<string.h>


class Matrix
{
public:
  int n;
  double ** e;

  Matrix(){}

  Matrix(int i){Allocate(i);}

  Matrix(int i, char* s)
  {
    Allocate(i);
    *this=s;
  }

  ~Matrix()
  {
    DeAllocate();
  }


  void Allocate(int i)
  {
    n = i;
    e = new double*[n];
    e[0] = new double[n*n];
    int j;
    for(j=0;j<n;j++)
    {
      e[j]=&e[0][j*n];
    }
  }

  void DeAllocate()
  {
    if(n>0)
    {

      e = new double*[n];
      delete []e[0];
      delete []e;
      delete e;
    }
  }
  double &operator()(int i, int j)
  {
    return e[i][j];
  }

  void operator=(char *s)
  {
    char *ss;
    ss=new char[strlen(s)];
    strcpy(ss,s);
    char *Tokens = strtok(ss," ,;");
    int i, j;
    for(i=0 ; i<n;  i++)
      for(j=0 ; j<n;  j++)
      {
        sscanf(Tokens,"%lf",&e[i][j]);
        Tokens = strtok (NULL, " ");
      }
  }

  void operator=(Matrix right)
  {
    int i, j;

    for(i=0; i<n;i++)
    {
      for(j=0; j<n;j++)
        e[i][j]=right.e[i][j];
    }
  }

  Matrix operator+(Matrix right)
  {
    int i, j;
    Matrix result;
    result.Allocate(n);

    for(i=0; i<n;i++)
    {
      for(j=0; j<n;j++)
        result.e[i][j] = e[i][j] + right.e[i][j];
    }
    return result;
  }

  Matrix operator-(Matrix right)
  {
    int i, j;
    Matrix result;
    result.Allocate(n);

    for(i=0; i<n;i++)
    {
      for(j=0; j<n;j++)
        result.e[i][j] = e[i][j] - right.e[i][j];
    }
    return result;
  }

  Matrix operator*(double right)
  {
    int i, j;
    Matrix result;
    result.Allocate(n);

    for(i=0; i<n;i++)
    {
      for(j=0; j<n;j++)
        result.e[i][j] = e[i][j]*right;
    }

    return result;
  }

  void matrixPrint()
  {
    int i, j;

    for(i=0; i<n;i++)
    {
      for(j=0; j<n;j++)
      {
        printf("%10.4lf",e[i][j]);
      }
      printf("\n");
    }
  }
};



int main()
{
  Matrix m1(2);
  Matrix m2(2," 1, 2; 3, 4"); 
  {
    Matrix m3;
  }

  return 0;
}
